/********************************************************/
/* Program         : util.c 							*/
/* Function        : utilities for social jewlery		*/
/* Author          : Chris Coulston     				*/
/* Platform        : HiTech (Lite Mode)  V9.71a			*/
/* Target          : PIC16LF1825 						*/
/*    			   : 14-pin SMT version					*/
/********************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <htc.h>
#include <pic16lf1825.h>
#include "iColor.h"

/********************************************************/
/*					putch								*/
/*														*/
/* Required for the HiTech compiler so that printf		*/
/* knows to go to RS232 rather than some other 			*/
/* "terminal" output.  Silly if you ask me because you	*/
/* can always use sprintf to format strings and then	*/
/* send to a device										*/
/********************************************************/
void putch(unsigned char byte) 
{
	while(!TXIF); 			/* Wait for TX Buffer Empty */
	TXREG = byte;
} // end putch


/********************************************************/
/*					MyPrint								*/
/*														*/
/* Required for the HiTech compiler so that printf		*/
/********************************************************/
void Myprintf (char *ptr) {

	while (*ptr != 0x00) putch(*ptr++);

} // end Myprintf
