//============================================================================
// Hierarchical state machine manager
//
// Hcmd.C : Exemple of a state machine definition (command exemple)
//
// (c) Robert Lacoste 2013, 
// Based on ideas from Miro Samek's book "Practival UML statecharts in C/C++)"
//
// Use this software freely, but provided without any warranty or support
//============================================================================

#include <stdio.h>
#include <stdlib.h>
#include "Hcmd.h"
#include "Timer.h"


//----------------------------------------------------------------------------
// Applicative constant and variables
//----------------------------------------------------------------------------

// Name of this specific HSM
#define HSM_NAME Hcmd

char pump;


//----------------------------------------------------------------------------
// State machine initialisation
//----------------------------------------------------------------------------

HSMINIT(HSM_PRIORITY_HIGH,AwaitingDistribution)


//----------------------------------------------------------------------------
// State handlers (one per state)
//----------------------------------------------------------------------------

STATE(AwaitingDistribution)
		WHENENTRY
			DO
				pump=0;
			END
		ENDEVENT
		WHENEVENT(Hcmd_GIVE_SOME)
			DO
				NEWSTATE(Distributing)
			END
		ENDEVENT
ENDSTATE


STATE(Distributing)
		WHENENTRY
			DO
				TimerArm(TIMER_T3,HSM_ID_Hcmd,5000); printf("Distributing !\n");
			END
		ENDEVENT
		WHENEXIT
			DO
				printf("Drink safely-Please wait before next drink !\n");
			END
		ENDEVENT
		WHENEVENT(TIMER_TIMEOUT_T3)
			DO
				NEWSTATE(AwaitingDistribution)
			END
		ENDEVENT
ENDSTATE

// END OF FILE

