//============================================================================
// Hierarchical state machine manager
//
// Hcmd.C : Exemple of a state machine definition (command exemple)
//
// (c) Robert Lacoste 2013, 
// Based on ideas from Miro Samek's book "Practival UML statecharts in C/C++)"
//
// Use this software freely, but provided without any warranty or support
//============================================================================

#include <stdio.h>
#include <stdlib.h>
#include "Hcmd.h"
#include "Timer.h"


//----------------------------------------------------------------------------
// Applicative constant and variables
//----------------------------------------------------------------------------

char pump;


//----------------------------------------------------------------------------
// State machine initialisation
//----------------------------------------------------------------------------

void HcmdInit(void)
{
	HsmPriority[HSM_ID_Hcmd]=HSM_PRIORITY_HIGH;
	HsmSetNewState(HSM_ID_Hcmd,&HcmdState_AwaitingDistribution);
}


//----------------------------------------------------------------------------
// State handlers (one per state)
//----------------------------------------------------------------------------

void HcmdState_AwaitingDistribution(const HSM_T_SIGNAL Signal)
{
	switch(Signal.SignalId)
	{
		case HSM_ON_ENTRY : 
			pump=0;
			break;
		case HSM_ON_EXIT : 
			break;
		case Hcmd_GIVE_SOME :
			HsmSetNewState(HSM_ID_Hcmd,&HcmdState_Distributing);
			break;
	}
}


void HcmdState_Distributing(const HSM_T_SIGNAL Signal)
{
	switch(Signal.SignalId)
	{
		case HSM_ON_ENTRY : 
			TimerArm(TIMER_T3,HSM_ID_Hcmd,5000); printf("Distributing !\n");
			break;
		case HSM_ON_EXIT : 
			printf("Drink safely-Please wait before next drink !\n");
			break;
		case TIMER_TIMEOUT_T3 :
			HsmSetNewState(HSM_ID_Hcmd,&HcmdState_AwaitingDistribution);
			break;
	}
}

// END OF FILE

