//============================================================================
// Hierarchical state machine manager
//
// Hkbd.H : Exemple of a state machine definition (keyboard manager exemple)
//
// (c) Robert Lacoste 2013, 
// Based on ideas from Miro Samek's book "Practival UML statecharts in C/C++)"
//
// Use this software freely, but provided without any warranty or support
//============================================================================

#include "HSM.h"

// Number of this specific HSM, should be unique
#define HSM_ID_Hkbd 0

// Application-specific signals
typedef enum 
{
	Hkbd_KEY_ACTIVATE,
	Hkbd_KEY_DIGIT,
	Hkbd_KEY_ALPHAMODE,
	Hkbd_KEY_DEL,
	Hkbd_KEY_ENTER
} Hkbd_SIGNALS;

// Prototype declarations of the initialisation and state handlers
void HkbdInit(void);
void HkbdState_WaitingActivation(const HSM_T_SIGNAL Signal);
void HkbdState_WaitingDigits(const HSM_T_SIGNAL Signal);
void HkbdState_WaitingAlpha(const HSM_T_SIGNAL Signal);
void HkbdState_WaitingSafetyDelay(const HSM_T_SIGNAL Signal);
void HkbdState_MacroStateDigits (const HSM_T_SIGNAL Signal);

// END OF FILE

